

#ifndef MAXIMATECC_INC_J1939_H_
#define MAXIMATECC_INC_J1939_H_

//#include "../Inc/Common.h"
#include "../../../Middlewares/Third_Party/J1939/j1939lib_ml/inc/j1939_j1939.h"

/*!
 * J1939 Control Platform Service configuration
 */
#define J1939_CTRL_RX_TX_MAX_Q_SIZE		10

/*!
 * J1939 index
 */
#define J1939_FUNC_INDEX	    		0
#define J1939_RESULT_INDEX    			0
#define J1939_SUB_FUNC_INDEX			1

/*!
 * J1939 DM Message index
 */
#define CAN1_DEST_ADDRESS     			1
#define SEND_CAN1_DM1_MSG     			2
#define SEND_CAN1_DM2_MSG     			3
#define SEND_CAN1_DM3_MSG     			4

/*!
 * J1939 SDK Message
 */
typedef enum __J1939_MSG
{
	SET_J1939,
}J1939_MSG;


/*!
 * J1939 SDK Message
 */
typedef enum __J1939SDK_Event
{
	J1939_MSG_EVENT,
}J1939SDK_Event;

/*!
 * J1939 Function
 */
typedef enum __j1939_Func
{
	CAN1_DM1,
	CAN1_DM2,
	CAN1_DM3,
	CAN1_D_ADD,
}j1939_Func;

/*!
 * J1939 USER Interface configuration
 */
typedef struct {
    uint8_t claimAddress;
	uint8_t canChannel;
	uint16_t BitRate;
	J1939_CONFIG_T *J1939Config;
}J1939Interface;

/* Private function prototypes -----------------------------------------------*/
float ConvertReadableData(uint32_t ivalue, const J1939_MAPPING_T_EXT mapping_ext[], uint8_t rowel);

#endif /* MAXIMATECC_INC_J1939_H_ */
