/****************************************************************************
              Copyright (c) 2022 Maxima Technologies and Systems
                           All Rights Reserved

   File Name          : memory_management.h
   Author             : Rajesh
   Version            : V0.0.0.1
   Origination Date   : 21/01/2022
   Description        : Header File.
   Environment        : Independant
   Processor:         : Independant

-----------------------------------------------------------------------------
   Description:

		This file contains the memory management declaration
-----------------------------------------------------------------------------
	File Revision History:
-----------------------------------------------------------------------------
   Version             Date                 Programmer
   0.0.0.1              21/01/2022          Rajesh

   Notes:              - Initial Version
-----------------------------------------------------------------------------
*****************************************************************************
THIS FILE CONTAINS INTELLECTUAL PROPERTY OF MAXIMA TECHNOLOGIES AND SYSTEMS.
UNAUTHORIZED REDISTRIBUTION OF THIS SOURCE CODE, IN WHOLE OR PART, WITHOUT
THE EXPRESS WRITTEN PERMISSION OF MAXIMA TECHNOLOGIES IS STRICTLY PROHIBITED.
****************************************************************************/

#ifndef _MEMORY_MANAGEMENT_H_
#define	_MEMORY_MANAGEMENT_H_

/* USER CODE BEGIN EFP */
/*!
 * Function declaration
 */
uint8_t *ai280_memory_alloc();
void ai280_memory_free(uint8_t *mbuf);
void start_memory_management(void);

#if (SDK_SERVICE_FDCAN == PS_ENABLE)

void can1_rx_memory_management(void);
void canrx1_memory_free(uint8_t *mbuf);
void put_can1_data_to_rxbufq(uint8_t *rx_data);
void clear_can1_rxQ();
uint8_t *can1rx__memory_alloc();
uint16_t get_can1_availablerxdata();
uint8_t *get_can1_data_from_rxbufq(uint8_t *user_buf);

#endif	//SDK_SERVICE_FDCAN
/* USER CODE END EFP */

/* USER CODE BEGIN defined Macro */
/*!
 * Queue timeout Macro
 */

#define MEM_Q_TIMEOUT   20

/* USER CODE END defined Macro */

#endif	//_MEMORY_MANAGEMENT_H_

/**************** (C) COPYRIGHT 2022 Maxima Technologies *******************/
/***************************** END OF FILE *********************************/
