/****************************************************************************
              Copyright (c) 2022 Maxima Technologies and Systems
                           All Rights Reserved

   File Name          : PowerMonitor_Platformservice.h
   Author             : Arjun
   Version            : V0.0.0.1
   Origination Date   : 25/02/2022
   Description        : Header File.
   Environment        : Independent
   Processor:         : STM32H743IIT6

-----------------------------------------------------------------------------
   Description:

   This file contains the Power Monitor platform service declarations

-----------------------------------------------------------------------------
	File Revision History:
-----------------------------------------------------------------------------
   Version             Date                 Programmer
   0.0.0.1             25/02/2022			Arjun

   Notes:              - Initial Version
-----------------------------------------------------------------------------
*****************************************************************************
THIS FILE CONTAINS INTELLECTUAL PROPERTY OF MAXIMA TECHNOLOGIES AND SYSTEMS.
UNAUTHORIZED REDISTRIBUTION OF THIS SOURCE CODE, IN WHOLE OR PART, WITHOUT
THE EXPRESS WRITTEN PERMISSION OF MAXIMA TECHNOLOGIES IS STRICTLY PROHIBITED.
****************************************************************************/
#ifndef _POWER_MONITOR_PLATFORM_SERVICE_H_
#define	_POWER_MONITOR_PLATFORM_SERVICE_H_

/*!
 * Power Monitor TxQ and RxQ size.
 */
#define POWERMONITOR_RX_TX_MAX_Q_SIZE       10


#define TEMP_SENSOR_MIN_VAL				    -40
#define TEMP_SENSOR_MAX_VAL				    65535
#define BATTERY_MIN_VAL                     0
#define BATTERY_MAX_VAL                     32000

/*!
 * Power Monitor Timeout value
 */
#define PS_POWERMONITOR_TIMEOUT				1000

/* !
 * Power Monitor SDK Field Index
 */
#define PWR_MONITOR_FUNC_INDEX     			0
#define PWR_MONITOR_RESULT_INDEX           	0
#define PWR_MONITOR_GET_VAL     			1

/*!
 * Power Monitor Events
 */
typedef enum __POWERMONITOR_Event
{
	POWERMONITOR_TMR_EVENT,
	POWERMONITOR_MSG_EVENT,
}POWERMONITOR_Event;

/*!
 * Power Monitor SDK Message
 */
typedef enum __POWERMONITOR_MSG
{
	GET_BATTERY_LEVEL,
	GET_IGN_STATUS,
	GET_THERMOSTAT_LEVEL
}POWERMONITOR_MSG;

/*!
 * IGN Status
 */
typedef enum __IGN_STATUS
{
	IGN_OFF,
	IGN_ON
}IGN_STATUS;

/********* IGN GPIO *********/
#define IGN_DATA_PIN			    		GPIO_PIN_4
#define IGN_DATA_PORT			    		GPIOC

/********* ADC channels *********/
#define BATTERY_CHANNEL			    		8
#define TEMPERATURE_CHANNEL		    		13
#define VREF_CHANNEL                		14

int8_t PowerMonitor_DB_Init(void);

#endif	//_POWER_MONITOR_PLATFORM_SERVICE_H_

/**************** (C) COPYRIGHT 2022 Maxima Technologies *******************/
/***************************** END OF FILE *********************************/
