/****************************************************************************
              Copyright (c) 2022 Maxima Technologies and Systems
                           All Rights Reserved

   File Name          : DL_u32_Validation.c
   Author             : Rajesh
   Version            : V0.0.0.1
   Origination Date   : 21/01/2022
   Description        : C Source File.
   Environment        : Independent
   Processor:         : STM32H743IIT6

-----------------------------------------------------------------------------
   Description:

   This file contains the Data Layer unsigned 32 bits field validation function

-----------------------------------------------------------------------------
	File Revision History:
-----------------------------------------------------------------------------
   Version             Date                 Programmer
   0.0.0.1             21/01/2022           Rajesh

   Notes:              - Initial Version
-----------------------------------------------------------------------------
*****************************************************************************
THIS FILE CONTAINS INTELLECTUAL PROPERTY OF MAXIMA TECHNOLOGIES AND SYSTEMS.
UNAUTHORIZED REDISTRIBUTION OF THIS SOURCE CODE, IN WHOLE OR PART, WITHOUT
THE EXPRESS WRITTEN PERMISSION OF MAXIMA TECHNOLOGIES IS STRICTLY PROHIBITED.
****************************************************************************/

/* USER CODE BEGIN Includes */
#include "../../Maximatecc/Inc/Data_Layer.h"
#include "../Inc/Common.h"
#include "../Inc/Dl_U32_Validation.h"
/* USER CODE END Includes */


/* USER CODE BEGIN PV */
int8_t (*dl_u32_func  [(END_U32BIT   -1)    - START_U32BIT  ])( uint16_t, uint32_t);

extern pvt_variable pv;
/* USER CODE END PV */

/* USER CODE BEGIN PFP */

/* USER CODE END PFP */

/** @brief DB Validation function
 *
 *  This function initialize the DB Validation function for the each
 *  unsinged 32 bits field.
 *
 *  @param  None
 *
 *  @return None
 *
 */
void DB_u32_Field_Validation_Reg(void)
{
	/* Clear the Callback memory */
	memset (&dl_u32_func[0], 0x00, ((END_U32BIT   -1)    - START_U32BIT));

#if (SDK_SERVICE_CFG_INPUT == PS_ENABLE)

	/* CFG_INPUT_01_FREQUENCY Validation */
	dl_u32_func[CFG_INPUT_01_FREQUENCY - (START_U32BIT + 1)] = validate_cfg_frequency;

	/* CFG_INPUT_02_FREQUENCY Validation */
	dl_u32_func[CFG_INPUT_02_FREQUENCY - (START_U32BIT + 1)] = validate_cfg_frequency;

	/* CFG_INPUT_03_FREQUENCY Validation */
	dl_u32_func[CFG_INPUT_03_FREQUENCY - (START_U32BIT + 1)] = validate_cfg_frequency;

	/* CFG_INPUT_04_FREQUENCY Validation */
	dl_u32_func[CFG_INPUT_04_FREQUENCY - (START_U32BIT + 1)] = validate_cfg_frequency;

	/* CFG_INPUT_05_FREQUENCY Validation */
	dl_u32_func[CFG_INPUT_05_FREQUENCY - (START_U32BIT + 1)] = validate_cfg_frequency;

#else

	/* CFG_INPUT_01_FREQUENCY_DUMMY Validation */
	dl_u32_func[CFG_INPUT_01_FREQUENCY_DUMMY - (START_U32BIT + 1)] = validate_dummy_field_val;

	/* CFG_INPUT_02_FREQUENCY_DUMMY Validation */
	dl_u32_func[CFG_INPUT_02_FREQUENCY_DUMMY - (START_U32BIT + 1)] = validate_dummy_field_val;

	/* CFG_INPUT_03_FREQUENCY_DUMMY Validation */
	dl_u32_func[CFG_INPUT_03_FREQUENCY_DUMMY - (START_U32BIT + 1)] = validate_dummy_field_val;

	/* CFG_INPUT_04_FREQUENCY_DUMMY Validation */
	dl_u32_func[CFG_INPUT_04_FREQUENCY_DUMMY - (START_U32BIT + 1)] = validate_dummy_field_val;

	/* CFG_INPUT_05_FREQUENCY_DUMMY Validation */
	dl_u32_func[CFG_INPUT_05_FREQUENCY_DUMMY - (START_U32BIT + 1)] = validate_dummy_field_val;

#endif	//SDK_SERVICE_CFG_INPUT

#if (SDK_SERVICE_FDCAN == PS_ENABLE)
	/* CAN_CH0_FILTER_INDEX_ID Validation */
	dl_u32_func[CAN_CH0_FILTER_INDEX_ID - (START_U32BIT + 1)] = validate_filter_index_id;

	/* CAN_CH0_FILTER_INDEX_IDMASK Validation */
	dl_u32_func[CAN_CH0_FILTER_INDEX_IDMASK - (START_U32BIT + 1)] = validate_filter_index_idmask;

#else

	/* CAN_CH0_FILTER_INDEX_ID_DUMMY Validation */
	dl_u32_func[CAN_CH0_FILTER_INDEX_ID_DUMMY - (START_U32BIT + 1)] = validate_dummy_field_val;

	/* CAN_CH0_FILTER_INDEX_IDMASK_DUMMY Validation */
	dl_u32_func[CAN_CH0_FILTER_INDEX_IDMASK_DUMMY - (START_U32BIT + 1)] = validate_dummy_field_val;

#endif

#if (SDK_SERVICE_PM == PS_ENABLE)

#if (RTC_WAKEUP_SOURCE_STATE == PS_ENABLE)

	/* RTC_WAKEUP_TIMEOUT Validation */
	dl_u32_func[RTC_WAKEUP_TIMEOUT - (START_U32BIT + 1)] = validate_rtcwakeup_timeout;
#else

	/* DUMMY_WAKEUP_TIMEOUT Validation */
	dl_u32_func[DUMMY_WAKEUP_TIMEOUT - (START_U32BIT + 1)] = validate_dummy_field_val;
#endif	//RTC_WAKEUP_SOURCE_STATE

#endif	//SDK_SERVICE_PM

#if (THROUGH_PUT_SERVICE == PS_ENABLE)

	/* KEYPAD_ATIME Validation */
	dl_u32_func[KEYPAD_ABSTIME - (START_U32BIT + 1)] = validate_absolute_time;

	/* DIO_ATIME Validation */
	dl_u32_func[DIO_ABSTIME - (START_U32BIT + 1)] = validate_absolute_time;

	/* CI_ATIME Validation */
	dl_u32_func[CI_ABSTIME - (START_U32BIT + 1)] = validate_absolute_time;

	/* POWERMODE_ATIME Validation */
	dl_u32_func[POWERMODE_ABSTIME - (START_U32BIT + 1)] = validate_absolute_time;

	/* LED_ATIME Validation */
	dl_u32_func[LED_ABSTIME - (START_U32BIT + 1)] = validate_absolute_time;

	/* POWER_MONITOR_ATIME Validation */
	dl_u32_func[POWER_MONITOR_ABSTIME - (START_U32BIT + 1)] = validate_absolute_time;

	/* DEFAULT_ATIME Validation */
	dl_u32_func[DEFAULT_ABSTIME - (START_U32BIT + 1)] = validate_absolute_time;

	/* BLUETOOTH_ATIME Validation */
	dl_u32_func[BLUETOOTH_ABSTIME - (START_U32BIT + 1)] = validate_absolute_time;

	/* RTC_ATIME Validation */
	dl_u32_func[RTC_ABSTIME - (START_U32BIT + 1)] = validate_absolute_time;

	/* SW_TIMER_ATIME Validation */
	dl_u32_func[SW_TIMER_ABSTIME - (START_U32BIT + 1)] = validate_absolute_time;

	/* EEPROM_ATIME Validation */
	dl_u32_func[EEPROM_ABSTIME - (START_U32BIT + 1)] = validate_absolute_time;

	/* WATCHDOG_ATIME Validation */
	dl_u32_func[WATCHDOG_ABSTIME - (START_U32BIT + 1)] = validate_absolute_time;

	/* LCD_ATIME Validation */
	dl_u32_func[LCD_ABSTIME - (START_U32BIT + 1)] = validate_absolute_time;

	/* CAN_ATIME Validation */
	dl_u32_func[CAN_ABSTIME - (START_U32BIT + 1)] = validate_absolute_time;

	/* J1939_ATIME Validation */
	dl_u32_func[J1939_ABSTIME - (START_U32BIT + 1)] = validate_absolute_time;

	/* TOUCHGFX_ATIME Validation */
	dl_u32_func[TOUCHGFX_ABSTIME - (START_U32BIT + 1)] = validate_absolute_time;

#else

	/* KEYPAD_ATIME_DUMMY Validation */
	dl_u32_func[KEYPAD_ABSTIME_DUMMY - (START_U32BIT + 1)] = validate_dummy_field_val;

	/* DIO_ATIME_DUMMY Validation */
	dl_u32_func[DIO_ABSTIME_DUMMY - (START_U32BIT + 1)] = validate_dummy_field_val;

	/* CI_ATIME_DUMMY Validation */
	dl_u32_func[CI_ABSTIME_DUMMY - (START_U32BIT + 1)] = validate_dummy_field_val;

	/* POWERMODE_ATIME_DUMMY Validation */
	dl_u32_func[POWERMODE_ABSTIME_DUMMY - (START_U32BIT + 1)] = validate_dummy_field_val;

	/* LED_ATIME_DUMMY Validation */
	dl_u32_func[LED_ABSTIME_DUMMY - (START_U32BIT + 1)] = validate_dummy_field_val;

	/* POWER_MONITOR_ATIME_DUMMY Validation */
	dl_u32_func[POWER_MONITOR_ABSTIME_DUMMY - (START_U32BIT + 1)] = validate_dummy_field_val;

	/* DEFAULT_ATIME_DUMMY Validation */
	dl_u32_func[DEFAULT_ABSTIME_DUMMY - (START_U32BIT + 1)] = validate_dummy_field_val;

	/* BLUETOOTH_ATIME_DUMMY Validation */
	dl_u32_func[BLUETOOTH_ABSTIME_DUMMY - (START_U32BIT + 1)] = validate_dummy_field_val;

	/* RTC_ATIME_DUMMY Validation */
	dl_u32_func[RTC_ABSTIME_DUMMY - (START_U32BIT + 1)] = validate_dummy_field_val;

	/* SW_TIMER_ATIME_DUMMY Validation */
	dl_u32_func[SW_TIMER_ABSTIME_DUMMY - (START_U32BIT + 1)] = validate_dummy_field_val;

	/* EEPROM_ATIME Validation */
	dl_u32_func[EEPROM_ABSTIME_DUMMY - (START_U32BIT + 1)] = validate_dummy_field_val;

	/* WATCHDOG_ATIME Validation_DUMMY */
	dl_u32_func[WATCHDOG_ABSTIME_DUMMY - (START_U32BIT + 1)] = validate_dummy_field_val;

	/* LCD_ATIME Validation_DUMMY */
	dl_u32_func[LCD_ABSTIME_DUMMY - (START_U32BIT + 1)] = validate_dummy_field_val;

	/* CAN_ATIME Validation_DUMMY */
	dl_u32_func[CAN_ABSTIME_DUMMY - (START_U32BIT + 1)] = validate_dummy_field_val;

	/* J1939_ATIME Validation_DUMMY */
	dl_u32_func[J1939_ABSTIME_DUMMY - (START_U32BIT + 1)] = validate_dummy_field_val;

	/* TOUCHGFX_ATIME Validation_DUMMY */
	dl_u32_func[TOUCHGFX_ABSTIME_DUMMY - (START_U32BIT + 1)] = validate_dummy_field_val;

#endif	//THROUGH_PUT_SERVICE

}

#if (SDK_SERVICE_CFG_INPUT == PS_ENABLE)

/** @brief validate the frequency
 *
 *  This function validates the frequency value and
 *  return the status.
 *
 *  @param  cfg_idx [IN]     : configurable DB Field
 *          frequency [IN]   : frequency value
 *
 *  @return  1 : SUCCESS
 *           0 : FAILURE
 *
 */
int8_t validate_cfg_frequency(uint16_t cfg_idx, uint32_t frequency)
{
	if(!((MIN_FREQUENCY_RANGE <= frequency) && (MAX_FREQUENCY_RANGE > frequency)))
		return FAILURE;

	return SUCCESS;
}

/** @brief validate the current
 *
 *  This function validates the current value and
 *  return the status.
 *
 *  @param  cfg_idx [IN]  : configurable DB Field
 *          current [IN]  : current value
 *
 *  @return  1 : SUCCESS
 *           0 : FAILURE
 *
 */
int8_t validate_cfg_current(uint16_t cfg_idx, uint32_t current)
{
	if(!((MIN_CURRENT_RANGE <= current) && (MAX_CURRENT_RANGE > current)))
		return FAILURE;

	return SUCCESS;
}

#endif	//SDK_SERVICE_CFG_INPUT

#if (SDK_SERVICE_PM == PS_ENABLE)
/** @brief validate RTC timeout value
 *
 *  This function validates the RTC timeout value and
 *  sends the RTC timeout value to platform service.
 *
 *  @param  wakeup_idx [IN] : RTC DB Field
 *          state [IN]      : RTC State
 *
 *  @return  1 : SUCCESS
 *           0 : FAILURE
 *
 */
int8_t validate_rtcwakeup_timeout(uint16_t wakeup_idx, uint32_t timeout_val)
{
	if(!((PM_RTC_WAKEUP_MIN <= timeout_val) && (PM_RTC_WAKEUP_MAX >= timeout_val)))
		return FAILURE;

	return SUCCESS;
}
#endif

#if (SDK_SERVICE_FDCAN == PS_ENABLE)
/** @brief FDCAN filter index id validation
 *
 *  This function validates the fdcan index id.
 *
 *  @param  index_number [IN] : index id
 *          id [IN] 		  : fdcan id
 *
 *  @return  0 : FAILURE
 *  		 1 : SUCCESS
 *
 */
int8_t validate_filter_index_id(uint16_t index_number ,uint32_t id)
{
	if ((MIN_RANGE_FILTER_INDEX_STD <= id) && (MAX_RANGE_FILTER_INDEX_STD > id) &&
			(MIN_RANGE_FILTER_INDEX_EXE <= id) && (MAX_RANGE_FILTER_INDEX_EXE > id))
		return FAILURE;

    return SUCCESS;
}

/** @brief FDCAN filter index idmask validation
 *
 *  This function validates the fdcan index idmask.
 *
 *  @param  index_number [IN] : index idmask
 *          id [IN] 		  : fdcan idmask
 *
 *  @return  0 : FAILURE
 *  		 1 : SUCCESS
 *
 */
int8_t validate_filter_index_idmask(uint16_t index_number ,uint32_t id)
{
    if(!((FDCAN_FILTER_MASK == id) || (FDCAN_FILTER_RANGE_NO_EIDM == id)))
	    return FAILURE;

    return SUCCESS;
}
#endif	//SDK_SERVICE_FDCAN

#if (THROUGH_PUT_SERVICE == PS_ENABLE)

/** @brief Absolute Time validation
 *
 *  This function validates absolute time.
 *
 *  @param  db_idx [IN] : DB Index
 *          a_time [IN] : Absolute Time
 *
 *  @return  0 : FAILURE
 *  		 1 : SUCCESS
 *
 */
int8_t validate_absolute_time(uint16_t db_idx, uint32_t a_time)
{
	return SUCCESS;
}

#endif

/** @brief Dummy Field validation
 *
 *  This function validates the dummy field in the DB.
 *
 *  @param  dummy1 [IN] : Not used
 *          dummy2 [IN] : Not used
 *
 *  @return 0 : FAILURE
 *
 */
int8_t validate_dummy_field_val(uint16_t dummy1, uint32_t dummy2)
{
	return FAILURE;
}

/**************** (C) COPYRIGHT 2022 Maxima Technologies *******************/
/***************************** END OF FILE *********************************/
