/****************************************************************************
              Copyright (c) 2022 Maxima Technologies and Systems
                           All Rights Reserved

   File Name          : DL_u32_Validation.c
   Author             : Rajesh
   Version            : V0.0.0.1
   Origination Date   : 21/01/2022
   Description        : C Source File.
   Environment        : Independent
   Processor:         : STM32H743IIT6

-----------------------------------------------------------------------------
   Description:

   This file contains the Data Layer unsigned 32 bits field validation function

-----------------------------------------------------------------------------
	File Revision History:
-----------------------------------------------------------------------------
   Version             Date                 Programmer
   0.0.0.1             21/01/2022           Rajesh

   Notes:              - Initial Version
-----------------------------------------------------------------------------
*****************************************************************************
THIS FILE CONTAINS INTELLECTUAL PROPERTY OF MAXIMA TECHNOLOGIES AND SYSTEMS.
UNAUTHORIZED REDISTRIBUTION OF THIS SOURCE CODE, IN WHOLE OR PART, WITHOUT
THE EXPRESS WRITTEN PERMISSION OF MAXIMA TECHNOLOGIES IS STRICTLY PROHIBITED.
****************************************************************************/

/* USER CODE BEGIN Includes */
#include "../../Maximatecc/Inc/Data_Layer.h"
#include "../Inc/Common.h"
#include "../Inc/Dl_jU32_Validation.h"
/* USER CODE END Includes */


/* USER CODE BEGIN PV */
int8_t (*dl_ju32_func [(END_J1939U32BIT - 1) - START_J1939U32BIT])(uint16_t, uint32_t);

extern pvt_variable pv;
/* USER CODE END PV */

/* USER CODE BEGIN PFP */

/* USER CODE END PFP */

/** @brief DB Validation function
 *
 *  This function initialize the DB Validation function for the each
 *  unsinged 32 bits field.
 *
 *  @param  None
 *
 *  @return None
 *
 */
void DB_ju32_Field_Validation_Reg(void)
{
	/* Clear the Callback memory */
	memset (&dl_ju32_func[0], 0x00, ((END_J1939U32BIT - 1) - START_J1939U32BIT));

#if (SDK_SERVICE_J1939 == PS_ENABLE)

	/* IDENTIFY_NUMBER_60920 Validation */
	dl_ju32_func[IDENTIFY_NUMBER_60920 - (START_J1939U32BIT + 1)] = validate_j1939_u32_variable;

	/* IDENTIFY_NUMBER_60928 Validation */
	dl_ju32_func[IDENTIFY_NUMBER_60928 - (START_J1939U32BIT + 1)] = validate_j1939_u32_variable;

#endif

}

#if (SDK_SERVICE_J1939 == PS_ENABLE)
/** @brief validation j1939 variable
 *
 *  This function validates the j1939 variable.
 *
 *  @param  db_idx [IN]  : DB Field
 *          val    [IN]  : variable val
 *
 *  @return  1 : SUCCESS
 *           0 : FAILURE
 *
 */
int8_t validate_j1939_u32_variable(uint16_t db_idx, uint32_t val)
{
	return SUCCESS;
}

#endif

/**************** (C) COPYRIGHT 2022 Maxima Technologies *******************/
/***************************** END OF FILE *********************************/
