/****************************************************************************
              Copyright (c) 2022 Maxima Technologies and Systems
                           All Rights Reserved

   File Name          : Through_Put_service.c
   Author             : Adrush
   Version            : V0.0.0.1
   Origination Date   : 21/01/2022
   Description        : C Source File.
   Environment        : Independent
   Processor:         : STM32H743IIT6

-----------------------------------------------------------------------------
   Description:

   This file contains the Through put service initialization functions

-----------------------------------------------------------------------------
	File Revision History:
-----------------------------------------------------------------------------
   Version             Date                 Programmer
   0.0.0.1             21/01/2022           Adrush

   Notes:              - Initial Version
-----------------------------------------------------------------------------
*****************************************************************************
THIS FILE CONTAINS INTELLECTUAL PROPERTY OF MAXIMA TECHNOLOGIES AND SYSTEMS.
UNAUTHORIZED REDISTRIBUTION OF THIS SOURCE CODE, IN WHOLE OR PART, WITHOUT
THE EXPRESS WRITTEN PERMISSION OF MAXIMA TECHNOLOGIES IS STRICTLY PROHIBITED.
****************************************************************************/

/* Include Header files */
#include "../Inc/Common.h"
#include "stdlib.h"

/* USER CODE BEGIN PV */

#if (THROUGH_PUT_SERVICE == PS_ENABLE)
/* USER CODE BEGIN PV */
extern pvt_variable pv;
/* USER CODE END PV */

//char *tp_buffer = 0xC0180000;
char tp_buffer[1000];
/** @brief ThroughPut service task
 *
 *  This function starts the ThroughPut Service
 *  task.
 *
 *  @param  pvParameters : Task Private structure
 *
 *  @return none
 *
 */
void TP_ServiceStart(void *pvParameters)
{
	uint8_t p_time = 0;
	uint32_t a_time = 0;
	char *token, *token1, *token2;

	char *tpkt = NULL;
	/*
	 * need to define the macro in the FreeRTOSConfig.h
	 * extern volatile uint32_t ulHighFrequencyTimerTicks;
	 * #define portCONFIGURE_TIMER_FOR_RUN_TIME_STATS() (ulHighFrequencyTimerTicks = 0UL)
	 * #define portGET_RUN_TIME_COUNTER_VALUE() ulHighFrequencyTimerTicks
	 * */

	/* need to enable the macro in the FreeRTOS.h file
	 * #define configUSE_TRACE_FACILITY 1
	 * #define configUSE_STATS_FORMATTING_FUNCTIONS 1
	 * #define configGENERATE_RUN_TIME_STATS 1
	 * */
	while(1)
	{
		vTaskDelay(1000);
		if(tpkt == NULL)
		{
			memset(tp_buffer, 0x00, 1000);
			vTaskGetRunTimeStats((char *)tp_buffer);
			tpkt = tp_buffer;
		}

		token = strtok_r((char *)tpkt, "\r\n", (char **)&tpkt);

		if(0 == strncmp(token, "Keypad", strlen("Keypad")))
		{
			token1  = strtok_r((char *)token, "\t", (char **)&token);
			token1  = strtok_r((char *)token, "\t", (char **)&token);
			a_time = atoi(token1);

			/* Set Keypad Absolute Time to DB */
			Set_DL(KEYPAD_ABSTIME, (uint8_t *)&a_time);

			token1  = strtok_r((char *)token, "\t\t<", (char **)&token);
			token2  = strtok_r((char *)token1, "%", (char **)&token1);
			p_time = (uint8_t)atoi(token2);

			/* Set Keypad Percentage Time to DB */
			Set_DL(KEYPAD_PERTIME, (uint8_t *)&p_time);

		}

		if(0 == strncmp(token, "Digital_Output", strlen("Digital_Output")))
		{
			token1  = strtok_r((char *)token, "\t", (char **)&token);
			token1  = strtok_r((char *)token, "\t", (char **)&token);
			a_time = atoi(token1);

			/* Set DIO Absolute Time to DB */
			Set_DL(DIO_ABSTIME, (uint8_t *)&a_time);

			token1  = strtok_r((char *)token, "\t\t<", (char **)&token);
			token2  = strtok_r((char *)token1, "%", (char **)&token1);
			p_time = (uint8_t)atoi(token2);

			/* Set DIO Percentage Time to DB */
			Set_DL(DIO_PERTIME, (uint8_t *)&p_time);
		}

		if(0 == strncmp(token, "CfgInput", strlen("CfgInput")))
		{
			token1  = strtok_r((char *)token, "\t", (char **)&token);
			token1  = strtok_r((char *)token, "\t", (char **)&token);
			a_time = atoi(token1);

			/* Set CI Absolute Time to DB */
			Set_DL(CI_ABSTIME, (uint8_t *)&a_time);

			token1  = strtok_r((char *)token, "\t\t<", (char **)&token);
			token2  = strtok_r((char *)token1, "%", (char **)&token1);
			p_time = (uint8_t)atoi(token2);

			/* Set CI Percentage Time to DB */
			Set_DL(CI_PERTIME, (uint8_t *)&p_time);
		}

		if(0 == strncmp(token, "PM", strlen("PM")))
		{
			token1  = strtok_r((char *)token, "\t", (char **)&token);
			token1  = strtok_r((char *)token, "\t", (char **)&token);
			a_time = atoi(token1);

			/* Set PM Absolute Time to DB */
			Set_DL(POWERMODE_ABSTIME, (uint8_t *)&a_time);

			token1  = strtok_r((char *)token, "\t\t<", (char **)&token);
			token2  = strtok_r((char *)token1, "%", (char **)&token1);
			p_time = (uint8_t)atoi(token2);

			/* Set PM Percentage Time to DB */
			Set_DL(POWERMODE_PERTIME, (uint8_t *)&p_time);
		}

		if(0 == strncmp(token, "LED_Service", strlen("LED_Service")))
		{
			token1  = strtok_r((char *)token, "\t", (char **)&token);
			token1  = strtok_r((char *)token, "\t", (char **)&token);
			a_time = atoi(token1);

			/* Set LED Absolute Time to DB */
			Set_DL(LED_ABSTIME, (uint8_t *)&a_time);

			token1  = strtok_r((char *)token, "\t\t<", (char **)&token);
			token2  = strtok_r((char *)token1, "%", (char **)&token1);
			p_time = (uint8_t)atoi(token2);

			/* Set LED Percentage Time to DB */
			Set_DL(LED_PERTIME, (uint8_t *)&p_time);
		}

		if(0 == strncmp(token, "Power_Monitor", strlen("Power_Monitor")))
		{
			token1  = strtok_r((char *)token, "\t", (char **)&token);
			token1  = strtok_r((char *)token, "\t", (char **)&token);
			a_time = atoi(token1);

			/* Set Power Monitor Absolute Time to DB */
			Set_DL(POWER_MONITOR_ABSTIME, (uint8_t *)&a_time);

			token1  = strtok_r((char *)token, "\t\t<", (char **)&token);
			token2  = strtok_r((char *)token1, "%", (char **)&token1);
			p_time = (uint8_t)atoi(token2);

			/* Set Power Monitor Percentage Time to DB */
			Set_DL(POWER_MONITOR_PERTIME, (uint8_t *)&p_time);
		}

		if(0 == strncmp(token, "defaultTask", strlen("defaultTask")))
		{
			token1  = strtok_r((char *)token, "\t", (char **)&token);
			token1  = strtok_r((char *)token, "\t", (char **)&token);
			a_time = atoi(token1);

			/* Set Default Absolute Time to DB */
			Set_DL(DEFAULT_ABSTIME, (uint8_t *)&a_time);

			token1  = strtok_r((char *)token, "\t\t<", (char **)&token);
			token2  = strtok_r((char *)token1, "%", (char **)&token1);
			p_time = (uint8_t)atoi(token2);

			/* Set Default Percentage Time to DB */
			Set_DL(DEFAULT_PERTIME, (uint8_t *)&p_time);

		}

		if(0 == strncmp(token, "BLE", strlen("BLE")))
		{
			token1  = strtok_r((char *)token, "\t", (char **)&token);
			token1  = strtok_r((char *)token, "\t", (char **)&token);
			a_time = atoi(token1);

			/* Set BlueTooth Absolute Time to DB */
			Set_DL(BLUETOOTH_ABSTIME, (uint8_t *)&a_time);

			token1  = strtok_r((char *)token, "\t\t<", (char **)&token);
			token2  = strtok_r((char *)token1, "%", (char **)&token1);
			p_time = (uint8_t)atoi(token2);

			/* Set BlueTooth Percentage Time to DB */
			Set_DL(BLUETOOTH_PERTIME, (uint8_t *)&p_time);
		}

		if(0 == strncmp(token, "RTC", strlen("RTC")))
		{
			token1  = strtok_r((char *)token, "\t", (char **)&token);
			token1  = strtok_r((char *)token, "\t", (char **)&token);
			a_time = atoi(token1);

			/* Set RTC Absolute Time to DB */
			Set_DL(RTC_ABSTIME, (uint8_t *)&a_time);

			token1  = strtok_r((char *)token, "\t\t<", (char **)&token);
			token2  = strtok_r((char *)token1, "%", (char **)&token1);
			p_time = (uint8_t)atoi(token2);

			/* Set RTC Percentage Time to DB */
			Set_DL(RTC_PERTIME, (uint8_t *)&p_time);
		}

		if(0 == strncmp(token, "SWTimer", strlen("SWTimer")))
		{
			token1  = strtok_r((char *)token, "\t", (char **)&token);
			token1  = strtok_r((char *)token, "\t", (char **)&token);
			a_time = atoi(token1);

			/* Set SW Timer Absolute Time to DB */
			Set_DL(SW_TIMER_ABSTIME, (uint8_t *)&a_time);

			token1  = strtok_r((char *)token, "\t\t<", (char **)&token);
			token2  = strtok_r((char *)token1, "%", (char **)&token1);
			p_time = (uint8_t)atoi(token2);

			/* Set SW Timer Percentage Time to DB */
			Set_DL(SW_TIMER_PERTIME, (uint8_t *)&p_time);
		}

		if(0 == strncmp(token, "EE_Service", strlen("EE_Service")))
		{
			token1  = strtok_r((char *)token, "\t", (char **)&token);
			token1  = strtok_r((char *)token, "\t", (char **)&token);
			a_time = atoi(token1);

			/* Set EEPROM Absolute Time to DB */
			Set_DL(EEPROM_ABSTIME, (uint8_t *)&a_time);

			token1  = strtok_r((char *)token, "\t\t<", (char **)&token);
			token2  = strtok_r((char *)token1, "%", (char **)&token1);
			p_time = (uint8_t)atoi(token2);

			/* Set EEPROM Percentage Time to DB */
			Set_DL(EEPROM_PERTIME, (uint8_t *)&p_time);
		}

		if(0 == strncmp(token, "Watchdog", strlen("Watchdog")))
		{
			token1  = strtok_r((char *)token, "\t", (char **)&token);
			token1  = strtok_r((char *)token, "\t", (char **)&token);
			a_time = atoi(token1);

			/* Set WatchDog Absolute Time to DB */
			Set_DL(WATCHDOG_ABSTIME, (uint8_t *)&a_time);

			token1  = strtok_r((char *)token, "\t\t<", (char **)&token);
			token2  = strtok_r((char *)token1, "%", (char **)&token1);
			p_time = (uint8_t)atoi(token2);

			/* Set WatchDog Percentage Time to DB */
			Set_DL(WATCHDOG_PERTIME, (uint8_t *)&p_time);
		}

		if(0 == strncmp(token, "LCD", strlen("LCD")))
		{
			token1  = strtok_r((char *)token, "\t", (char **)&token);
			token1  = strtok_r((char *)token, "\t", (char **)&token);
			a_time = atoi(token1);

			/* Set LCD Absolute Time to DB */
			Set_DL(LCD_ABSTIME, (uint8_t *)&a_time);

			token1  = strtok_r((char *)token, "\t\t<", (char **)&token);
			token2  = strtok_r((char *)token1, "%", (char **)&token1);
			p_time = (uint8_t)atoi(token2);

			/* Set LCD Percentage Time to DB */
			Set_DL(LCD_PERTIME, (uint8_t *)&p_time);
		}

		if(0 == strncmp(token, "FDCAN", strlen("FDCAN")))
		{
			token1  = strtok_r((char *)token, "\t", (char **)&token);
			token1  = strtok_r((char *)token, "\t", (char **)&token);
			a_time = atoi(token1);

			/* Set CAN Absolute Time to DB */
			Set_DL(CAN_ABSTIME, (uint8_t *)&a_time);

			token1  = strtok_r((char *)token, "\t\t<", (char **)&token);
			token2  = strtok_r((char *)token1, "%", (char **)&token1);
			p_time = (uint8_t)atoi(token2);

			/* Set CAN Percentage Time to DB */
			Set_DL(CAN_PERTIME, (uint8_t *)&p_time);
		}

		if(0 == strncmp(token, "J1939Task", strlen("J1939Task")))
		{
			token1  = strtok_r((char *)token, "\t", (char **)&token);
			token1  = strtok_r((char *)token, "\t", (char **)&token);
			a_time = atoi(token1);

			/* Set J1939 Absolute Time to DB */
			Set_DL(J1939_ABSTIME, (uint8_t *)&a_time);

			token1  = strtok_r((char *)token, "\t\t<", (char **)&token);
			token2  = strtok_r((char *)token1, "%", (char **)&token1);
			p_time = (uint8_t)atoi(token2);

			/* Set J1939 Percentage Time to DB */
			Set_DL(J1939_PERTIME, (uint8_t *)&p_time);
		}
		if(0 == strncmp(token, "J1939Control", strlen("J1939Control")))
		{
			token1  = strtok_r((char *)token, "\t", (char **)&token);
			token1  = strtok_r((char *)token, "\t", (char **)&token);
			a_time = atoi(token1);

			/* Set TouchGFX Absolute Time to DB */
			Set_DL(J1939CTRL_ABSTIME, (uint8_t *)&a_time);

			token1  = strtok_r((char *)token, "\t\t<", (char **)&token);
			token2  = strtok_r((char *)token1, "%", (char **)&token1);
			p_time = (uint8_t)atoi(token2);

			/* Set TouchGFX Percentage Time to DB */
			Set_DL(J1939CTRL_PERTIME, (uint8_t *)&p_time);

		}
		if(0 == strncmp(token, "AITouchGFXTask", strlen("AITouchGFXTask")))
		{
			token1  = strtok_r((char *)token, "\t", (char **)&token);
			token1  = strtok_r((char *)token, "\t", (char **)&token);
			a_time = atoi(token1);

			/* Set TouchGFX Absolute Time to DB */
			Set_DL(TOUCHGFX_ABSTIME, (uint8_t *)&a_time);

			token1  = strtok_r((char *)token, "\t\t<", (char **)&token);
			token2  = strtok_r((char *)token1, "%", (char **)&token1);
			p_time = (uint8_t)atoi(token2);

			/* Set TouchGFX Percentage Time to DB */
			Set_DL(TOUCHGFX_PERTIME, (uint8_t *)&p_time);

		}
		if(0 == strncmp(token, "IDLE", strlen("IDLE")))
		{
			token1  = strtok_r((char *)token, "\t", (char **)&token);
			token1  = strtok_r((char *)token, "\t", (char **)&token);
			a_time = atoi(token1);

			/* Set TouchGFX Absolute Time to DB */
			Set_DL(IDLE_ABSTIME, (uint8_t *)&a_time);

			token1  = strtok_r((char *)token, "\t\t<", (char **)&token);
			token2  = strtok_r((char *)token1, "%", (char **)&token1);
			p_time = (uint8_t)atoi(token2);

			/* Set TouchGFX Percentage Time to DB */
			Set_DL(IDLE_PERTIME, (uint8_t *)&p_time);
		}
		if(0 == strncmp(token, "User_Task1", strlen("User_Task1")))
		{
			token1  = strtok_r((char *)token, "\t", (char **)&token);
			token1  = strtok_r((char *)token, "\t", (char **)&token);
			a_time = atoi(token1);

			/* Set TouchGFX Absolute Time to DB */
			Set_DL(USERTASK1_ABSTIME, (uint8_t *)&a_time);

			token1  = strtok_r((char *)token, "\t\t<", (char **)&token);
			token2  = strtok_r((char *)token1, "%", (char **)&token1);
			p_time = (uint8_t)atoi(token2);

			/* Set TouchGFX Percentage Time to DB */
			Set_DL(USERTASK1_PERTIME, (uint8_t *)&p_time);

		}
		if(0 == strncmp(token, "User_Task2", strlen("User_Task2")))
		{
			token1  = strtok_r((char *)token, "\t", (char **)&token);
			token1  = strtok_r((char *)token, "\t", (char **)&token);
			a_time = atoi(token1);

			/* Set TouchGFX Absolute Time to DB */
			Set_DL(USERTASK2_ABSTIME, (uint8_t *)&a_time);

			token1  = strtok_r((char *)token, "\t\t<", (char **)&token);
			token2  = strtok_r((char *)token1, "%", (char **)&token1);
			p_time = (uint8_t)atoi(token2);

			/* Set TouchGFX Percentage Time to DB */
			Set_DL(USERTASK2_PERTIME, (uint8_t *)&p_time);

		}
		if(0 == strncmp(token, "User_Task3", strlen("User_Task3")))
		{
			token1  = strtok_r((char *)token, "\t", (char **)&token);
			token1  = strtok_r((char *)token, "\t", (char **)&token);
			a_time = atoi(token1);

			/* Set TouchGFX Absolute Time to DB */
			Set_DL(USERTASK3_ABSTIME, (uint8_t *)&a_time);

			token1  = strtok_r((char *)token, "\t\t<", (char **)&token);
			token2  = strtok_r((char *)token1, "%", (char **)&token1);
			p_time = (uint8_t)atoi(token2);

			/* Set TouchGFX Percentage Time to DB */
			Set_DL(USERTASK3_PERTIME, (uint8_t *)&p_time);

		}
	}
}

/** @brief Start Through Put service
 *
 *  This function initializes the following modules
 *     ===> Start the Throughput service
 *
 *  @param  None
 *
 *  @return 0 : PS_SUCCESS
 *          1 : PS_FAILURE
 *
 */
int8_t Throughput_service_Start(void)
{
	BaseType_t xReturned;

	/* Start the Throughput service thread */
	xReturned = xTaskCreate(TP_ServiceStart, "ThroughPut",
			512, NULL, osPriorityIdle,   &pv.tp_task);

	if (xReturned != pdPASS)
	{
		LOGERROR("Unable to initialize the ThroughPut Thread\r\n");
		return PS_FAILURE;
	}

	LOGERROR("ThroughPut Service task created Successfully \r\n");

	return PS_SUCCESS;
}
#endif	//THROUGH_PUT_SERVICE

/**************** (C) COPYRIGHT 2022 Maxima Technologies *******************/
/***************************** END OF FILE *********************************/
