/****************************************************************************
              Copyright (c) 2022 Maxima Technologies and Systems
                           All Rights Reserved

   File Name          : CI.h
   Author             : Zaid
   Version            : V0.0.0.1
   Origination Date   : 04/02/2022
   Description        : Header File.
   Environment        : Independent
   Processor:         : STM32H743IIT6

-----------------------------------------------------------------------------
   Description:

   This file contains the Configurable Input configuration structures and macros

-----------------------------------------------------------------------------
	File Revision History:
-----------------------------------------------------------------------------
   Version             Date                 Programmer
   0.0.0.1             04/02/2022           Zaid

   Notes:              - Initial Version
-----------------------------------------------------------------------------
*****************************************************************************
THIS FILE CONTAINS INTELLECTUAL PROPERTY OF MAXIMA TECHNOLOGIES AND SYSTEMS.
UNAUTHORIZED REDISTRIBUTION OF THIS SOURCE CODE, IN WHOLE OR PART, WITHOUT
THE EXPRESS WRITTEN PERMISSION OF MAXIMA TECHNOLOGIES IS STRICTLY PROHIBITED.
****************************************************************************/
#ifndef _CONFIGURABLEINPUT_H_
#define	_CONFIGURABLEINPUT_H_

/************************** I2C Address ***************************************/
#define TCA9535_ADDRESS 		0x44

/*
 * Configurable Analog Input
 */
typedef enum _CAI1
{
	CONFIG_AI1,
	CONFIG_AI2,
	CONFIG_AI3,
	CONFIG_AI4,
	CONFIG_AI5,
	CONFIG_AI6,
}CAI;

int8_t CI_Init(I2C_HandleTypeDef *hi2c);
int8_t CI_AI1(I2C_HandleTypeDef *hi2c, uint8_t type);
int8_t CI_AI2(I2C_HandleTypeDef *hi2c, uint8_t type);
int8_t CI_AI3(I2C_HandleTypeDef *hi2c, uint8_t type);
int8_t CI_AI4(I2C_HandleTypeDef *hi2c, uint8_t type);
int8_t CI_AI5(I2C_HandleTypeDef *hi2c, uint8_t type);
int8_t CI_AI6(I2C_HandleTypeDef *hi2c, uint8_t type);
int8_t SetAI(I2C_HandleTypeDef *hi2c, uint8_t ai, INPUT_TYPE type);



#endif	//_CONFIGURABLEINPUT_H_

/**************** (C) COPYRIGHT 2022 Maxima Technologies *******************/
/***************************** END OF FILE *********************************/
