/****************************************************************************
              Copyright (c) 2022 Maxima Technologies and Systems
                           All Rights Reserved

   File Name          : Led.h
   Author             : Adrush
   Version            : V0.0.0.1
   Origination Date   : 04/02/2022
   Description        : Header File.
   Environment        : Independent
   Processor:         : STM32H743IIT6

-----------------------------------------------------------------------------
   Description:

   This file contains the board configuration structures and macros

-----------------------------------------------------------------------------
	File Revision History:
-----------------------------------------------------------------------------
   Version             Date                 Programmer
   0.0.0.1             04/02/2022           Adrush

   Notes:              - Initial Version
-----------------------------------------------------------------------------
*****************************************************************************
THIS FILE CONTAINS INTELLECTUAL PROPERTY OF MAXIMA TECHNOLOGIES AND SYSTEMS.
UNAUTHORIZED REDISTRIBUTION OF THIS SOURCE CODE, IN WHOLE OR PART, WITHOUT
THE EXPRESS WRITTEN PERMISSION OF MAXIMA TECHNOLOGIES IS STRICTLY PROHIBITED.
****************************************************************************/
#ifndef _LED_H_
#define	_LED_H_

/************************** I2C Address ***************************************/
#define TCA9535_ADDRESS 		0x44
/************************** I2C Registers *************************************/
#define TCA9535_INPUT_REG0 		0x00
#define TCA9535_INPUT_REG1 		0x01
#define TCA9535_OUTPUT_REG0		0x02
#define TCA9535_OUTPUT_REG1		0x03
#define TCA9535_POLARITY_REG0 	0x04
#define TCA9535_POLARITY_REG1 	0x05
#define TCA9535_CONFIG_REG0		0x06
#define TCA9535_CONFIG_REG1		0x07

/*!
 * LED Name
 */
typedef enum __led_num
{
	RED_LED = 1,
	AMBER_LED,
}led_num;

#define IO_EXP_TIMEOUT 			100

/*!
 * Function declaration
 */
int8_t Led_On(uint8_t led_num);
int8_t Led_Off(uint8_t led_num);


#endif	//_LED_H_

/**************** (C) COPYRIGHT 2022 Maxima Technologies *******************/
/***************************** END OF FILE *********************************/
