
/****************************************************************************
              Copyright (c) 2012 Maxima Technologies and Systems
                           All Rights Reserved

   File Name          : Template.h
   Author             : Name Last_Name
   Version            : V0.0.0.1
   Origination Date   : 04/25/2012
   Description        : C Header File.
   Environment        : Independant
   Processor:         : STM32H743IIT6

-----------------------------------------------------------------------------
   Description:

		General File Description
-----------------------------------------------------------------------------
	File Revision History:
-----------------------------------------------------------------------------
   Version             Date                 Programmer
   0.0.0.0              04/04/2011         Name Last_Name

   Notes:              - Initial Version
-----------------------------------------------------------------------------
   Version             Date                 Programmer
   0.0.0.1              31/03/2011         Name Last_Name

   Notes:              - Second Version
-----------------------------------------------------------------------------
*****************************************************************************
THIS FILE CONTAINS INTELLECTUAL PROPERTY OF MAXIMA TECHNOLOGIES AND SYSTEMS.
UNAUTHORIZED REDISTRIBUTION OF THIS SOURCE CODE, IN WHOLE OR PART, WITHOUT
THE EXPRESS WRITTEN PERMISSION OF MAXIMA TECHNOLOGIES IS STRICTLY PROHIBITED.
****************************************************************************/

#ifndef __EEPROM_SPI__H__
#define __EEPROM_SPI__H__

/* Includes ---------------------------------------------------------------*/
#include "main.h"
//#include "cmsis_os.h"

/* Public typedef ---------------------------------------------------------*/
/**
 * @brief EEPROM Operations statuses
 */
typedef enum
{
	EEPROM_STATUS_PENDING,
    EEPROM_STATUS_COMPLETE,
    EEPROM_STATUS_ERROR
} EepromOperations;

/* Public define ----------------------------------------------------------*/
/* M95040 SPI EEPROM defines */
#define EEPROM_WREN  			0x06  /*!< Write Enable */
#define EEPROM_WRDI  			0x04  /*!< Write Disable */
#define EEPROM_RDSR  			0x05  /*!< Read Status Register */
#define EEPROM_WRSR  			0x01  /*!< Write Status Register */
#define EEPROM_READ  			0x03  /*!< Read from Memory Array */
#define EEPROM_WRITE 			0x02  /*!< Write to Memory Array */

#define EEPROM_WIP_FLAG        	0x01  /*!< Write In Progress (WIP) flag */

#define EEPROM_PAGESIZE        	128    /*!< Pagesize according to documentation */
#define EEPROM_BUFFER_SIZE     	128    /*!< EEPROM Buffer size. Setup to your needs */

#define EEPROM_CS_HIGH()    	HAL_GPIO_WritePin(GPIOG, GPIO_PIN_9, GPIO_PIN_SET)
#define EEPROM_CS_LOW()     	HAL_GPIO_WritePin(GPIOG, GPIO_PIN_9, GPIO_PIN_RESET)

/* Public macro -----------------------------------------------------------*/
/* Public variables -------------------------------------------------------*/
/* Public functions declaration -------------------------------------------*/
void 	EEPROM_SPI_INIT(SPI_HandleTypeDef *hspi);
void 	EEPROM_eraseAll();
EepromOperations EEPROM_SPI_WriteBuffer(uint8_t* pBuffer, uint16_t WriteAddr, uint16_t NumByteToWrite);
EepromOperations EEPROM_WritePage(uint8_t* pBuffer, uint16_t WriteAddr, uint16_t NumByteToWrite);
EepromOperations EEPROM_SPI_ReadBuffer(uint8_t* pBuffer, uint16_t ReadAddr, uint16_t NumByteToRead);
uint8_t EEPROM_SPI_WaitStandbyState(void);

/* Low layer functions */
uint8_t EEPROM_SendByte(uint8_t byte);
void 	sEE_WriteEnable(void);
void 	sEE_WriteDisable(void);
void 	sEE_WriteStatusRegister(uint8_t regval);
uint8_t sEE_ReadStatusRegister(void);
void  	EEPROM_SPI_SendInstruction(uint8_t *instruction, uint8_t size);
void  	EEPROM_SPI_ReadStatusByte(SPI_HandleTypeDef SPIe, uint8_t *statusByte );
#endif 

/**************** (C) COPYRIGHT 2012 Maxima Technologies *******************/
/***************************** END OF FILE *********************************/ 
