/**
  ******************************************************************************
  * File Name          : TouchGFXHAL.cpp
  ******************************************************************************
  * This file is generated by TouchGFX Generator 4.18.1.
  ******************************************************************************
  * @attention
  *
  * Copyright (c) 2022 STMicroelectronics.
  * All rights reserved.
  *
  * This software is licensed under terms that can be found in the LICENSE file
  * in the root directory of this software component.
  * If no LICENSE file comes with this software, it is provided AS-IS.
  *
  ******************************************************************************
  */
#include <TouchGFXHAL.hpp>

/* USER CODE BEGIN TouchGFXHAL.cpp */
#include <touchgfx/hal/OSWrappers.hpp>
#include <STM32H7Instrumentation.hpp>
//#include <KeySampler.hpp>
/* USER CODE BEGIN private variables */
#include <touchgfx/hal/GPIO.hpp>
volatile bool firstFrameReadyToDisplay = false;
//static uint16_t* currFbBase = 0;
/* USER CODE END private variables */
extern "C"
{
#include "../../Drivers/Maximatecc/inc/LCD.h"
#include "cmsis_os.h"
#include <FreeRTOS.h>
#include <Queue.h>
#include "../../Core/Maximatecc/Inc/Common.h"

}
extern "C" void touchgfx_taskEntry();
extern DMA_HandleTypeDef hdma_memtomem_dma1_stream0;

bool os_inited = false;
using namespace touchgfx;

/* USER CODE BEGIN private class objects */
STM32H7Instrumentation mcuInstr;
//static KeySampler btnctrl;
uint32_t      user_button_press = 4;
QueueHandle_t ButtonEventQueue  = 0;
/* USER CODE END private class objects */

void TouchGFXHAL::initialize()
{
  /* USER CODE BEGIN initialize step 1 */
  
  if(ST7789V_Init() == FAIL)
  {
    assert(0 && "ST7789v incorrect driver");
  }
  
  /* USER CODE END initialize step 1 */
  // Calling parent implementation of initialize().
  //
  // To overwrite the generated implementation, omit call to parent function
  // and implemented needed functionality here.
  // Please note, HAL::initialize() must be called to initialize the framework.
  
  TouchGFXGeneratedHAL::initialize();
  
  /* USER CODE BEGIN initialize step 2 */
  lockDMAToFrontPorch(false);
  mcuInstr.init();
  setMCUInstrumentation(&mcuInstr);
  enableMCULoadCalculation(true);
  /* Create Queue with Button push events */
  ButtonEventQueue = xQueueCreate( 2, sizeof( uint32_t ) );
  if (ButtonEventQueue == 0)
  {
    configASSERT(0);
  }

  //setButtonController(&btnctrl);
  
  
  os_inited = true;

  /* USER CODE END initialize step 2 */
}

/**
 * Gets the frame buffer address used by the TFT controller.
 *
 * @return The address of the frame buffer currently being displayed on the TFT.
 */
uint16_t* TouchGFXHAL::getTFTFrameBuffer() const
{
    // Calling parent implementation of getTFTFrameBuffer().
    //
    // To overwrite the generated implementation, omit call to parent function
    // and implemented needed functionality here.

    return TouchGFXGeneratedHAL::getTFTFrameBuffer();
}

/**
 * Sets the frame buffer address used by the TFT controller.
 *
 * @param [in] address New frame buffer address.
 */
void TouchGFXHAL::setTFTFrameBuffer(uint16_t* address)
{
    // Calling parent implementation of setTFTFrameBuffer(uint16_t* address).
    //
    // To overwrite the generated implementation, omit call to parent function
    // and implemented needed functionality here.

    TouchGFXGeneratedHAL::setTFTFrameBuffer(address);
}

/**
 * This function is called whenever the framework has performed a partial draw.
 *
 * @param rect The area of the screen that has been drawn, expressed in absolute coordinates.
 *
 * @see flushFrameBuffer().
 */
void TouchGFXHAL::flushFrameBuffer(const touchgfx::Rect& rect)
{
  /*This flushFrameBuffer() function is generally used for MCUs with no TFT Controller*/
#if 0
   // Partial framebuffer might be supported for this platform only when Double
    // Buffering is enabled
    dma.flush();
#endif
    TouchGFXGeneratedHAL::flushFrameBuffer(rect);

    // Calling parent implementation of flushFrameBuffer(const touchgfx::Rect& rect).
    //
    // To overwrite the generated implementation, omit call to parent function
    // and implemented needed functionality here.
    // Please note, HAL::flushFrameBuffer(const touchgfx::Rect& rect) must
    // be called to notify the touchgfx framework that flush has been performed.
    // To calculate he start adress of rect,
    // use advanceFrameBufferToRect(uint8_t* fbPtr, const touchgfx::Rect& rect)
    // defined in TouchGFXGeneratedHAL.cpp
    /* Set Cursor */
  
    //ST7789V_SetDisplayWindow(rect.x, rect.y, rect.width, rect.height);

      /* Prepare to write to LCD RAM */
    ST7789V_WriteReg(ST7789V_WRITE_RAM, (uint16_t*)NULL, 0);


    /* Send Pixels - User defined function */
    this->copyFrameBufferBlockToLCD(rect);
 
}

bool TouchGFXHAL::blockCopy(void* RESTRICT dest, const void* RESTRICT src, uint32_t numBytes)
{
    return TouchGFXGeneratedHAL::blockCopy(dest, src, numBytes);
}

/**
 * Configures the interrupts relevant for TouchGFX. This primarily entails setting
 * the interrupt priorities for the DMA and LCD interrupts.
 */
void TouchGFXHAL::configureInterrupts()
{
    // Calling parent implementation of configureInterrupts().
    //
    // To overwrite the generated implementation, omit call to parent function
    // and implemented needed functionality here.

    TouchGFXGeneratedHAL::configureInterrupts();
}

/**
 * Used for enabling interrupts set in configureInterrupts()
 */
void TouchGFXHAL::enableInterrupts()
{
    // Calling parent implementation of enableInterrupts().
    //
    // To overwrite the generated implementation, omit call to parent function
    // and implemented needed functionality here.

    TouchGFXGeneratedHAL::enableInterrupts();
}

/**
 * Used for disabling interrupts set in configureInterrupts()
 */
void TouchGFXHAL::disableInterrupts()
{
    // Calling parent implementation of disableInterrupts().
    //
    // To overwrite the generated implementation, omit call to parent function
    // and implemented needed functionality here.

    TouchGFXGeneratedHAL::disableInterrupts();
}

/**
 * Configure the LCD controller to fire interrupts at VSYNC. Called automatically
 * once TouchGFX initialization has completed.
 */
void TouchGFXHAL::enableLCDControllerInterrupt()
{
    // Calling parent implementation of enableLCDControllerInterrupt().
    //
    // To overwrite the generated implementation, omit call to parent function
    // and implemented needed functionality here.

    TouchGFXGeneratedHAL::enableLCDControllerInterrupt();
}

/**
The following function TouchGFXHAL::copyFrameBufferBlockToLCD is, in this example,
a user defined function that sends one line of the updated area (Rect) at a time, 
ensuring to progress the framebuffer pointer accordingly.
 */
void TouchGFXHAL::copyFrameBufferBlockToLCD(const Rect& rect)
{
    __IO uint16_t* ptr;
    uint16_t height;
    // This can be accelerated using regular DMA hardware
//    OSWrappers::tryTakeFrameBufferSemaphore();
    for (height = 0; height < rect.height ; height++)
    {
        ptr = getClientFrameBuffer() + rect.x + (height + rect.y) * HAL::DISPLAY_WIDTH;
        //LCD_IO_WriteMultipleData((uint16_t*)ptr, rect.width);
        LCD_WriteMultipleData((uint16_t*)ptr, rect.width,height);
        //(uint16_t *)0xCC400000)
        /**
          * @brief  Start the DMA Transfer with interrupt enabled.
          * @param  hdma:       pointer to a DMA_HandleTypeDef structure that contains
          *                     the configuration information for the specified DMA Stream.
          * @param  SrcAddress: The source memory Buffer address
          * @param  DstAddress: The destination memory Buffer address
          * @param  DataLength: The length of data to be transferred from source to destination
          * @retval HAL status
          */
        //HAL_DMA_Start_IT(&hdma_memtomem_dma1_stream0, ui32SrcAdr, (uint32_t)0xCC400000, 240);
        /* Wait for the DMA transfer to complete */

        //OSWrappers::tryTakeFrameBufferSemaphore();
    }

}
/*
Selecting a custom display interface also requires developers to implement a custom TouchGFX
Application Tick driver that signals OSWrappers::signalVSync() to unblock the TouchGFX Engine
Main loop. 

Usually, displays used along with MCUS that have no TFT Controllers can provide a Tearing
Effect signal that is connected to the MCU.

*/
void TouchGFXHAL::taskEntry()
{
    enableLCDControllerInterrupt();
    enableInterrupts();
    os_inited = true;

   // OSWrappers::waitForVSync();
    backPorchExited();

    for (;;)
    {
        //osDelay(100);
        OSWrappers::waitForVSync();
        backPorchExited();
    }
}

void TouchGFXHAL::endFrame()
{
    HAL::endFrame();
    if (frameBufferUpdatedThisFrame)
    {
        if (!firstFrameReadyToDisplay)
        {
            firstFrameReadyToDisplay = true;
            //ST7789V_DisplayOn();
        }
    }
}
/* USER CODE BEGIN extern C functions */

extern "C" {

    portBASE_TYPE IdleTaskHook(void* p)
    {
        if ((int)p) //idle task sched out
        {
            touchgfx::HAL::getInstance()->setMCUActive(true);
        }
        else //idle task sched in
        {
            touchgfx::HAL::getInstance()->setMCUActive(false);
        }
        return pdTRUE;
    }

    void TouchGFX_TickHandler(uint8_t PinStatus)
    {
        if (os_inited)
        {
            if (PinStatus) /* Raising edge : entering Active Area */
            {
                HAL::getInstance()->vSync();
                OSWrappers::signalVSync();
                // Swap frame buffers immediately instead of waiting for the task to be scheduled in.
                // Note: task will also swap when it wakes up, but that operation is guarded and will not have
                // any effect if already swapped.
                HAL::getInstance()->swapFrameBuffers();
                GPIO::set(GPIO::VSYNC_FREQ);
            }
            else /* Falling edge : exiting active area */
            {
                GPIO::clear(GPIO::VSYNC_FREQ);
                HAL::getInstance()->frontPorchEntered();
            }
        }
    }

    void release_FrameBufferSemaphore(void)
    {
        OSWrappers::giveFrameBufferSemaphore();
    }

}
    /* USER CODE END extern C functions */
///**
//Instead of advancing ptr manually, the TouchGFX Generator will generate a 
//function advanceFrameBufferToRect that advances ptr according to the position 
//of Rect in the framebuffer.
//**/
//inline uint8_t* TouchGFXGeneratedHAL::advanceFrameBufferToRect(uint8_t* fbPtr, 
//                                                               const touchgfx::Rect& rect) const
//{
//    //       Advance vertically                   Advance horizontally
//    fbPtr += rect.y * lcd().framebufferStride() + rect.x * 2;
//    return fbPtr;
//}
/* USER CODE END TouchGFXHAL.cpp */

/************************ (C) COPYRIGHT STMicroelectronics *****END OF FILE****/
